(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('highlight.js/lib'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'highlight.js/lib', '@angular/common'], factory) :
	(factory((global.td = global.td || {}, global.td.highlight = global.td.highlight || {}),global.ng.core,global.lib,global.ng.common));
}(this, (function (exports,core,lib,common) { 'use strict';

core = 'default' in core ? core['default'] : core;
lib = 'default' in lib ? lib['default'] : lib;
common = 'default' in common ? common['default'] : common;

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};



function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var highlight_component = createCommonjsModule(function (module, exports) {
"use strict";
var __decorate = (commonjsGlobal && commonjsGlobal.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (commonjsGlobal && commonjsGlobal.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = core;

var TdHighlightComponent = (function () {
    function TdHighlightComponent(renderer) {
        this.renderer = renderer;
        this.language = 'javascript';
    }
    TdHighlightComponent.prototype.ngAfterViewInit = function () {
        if (!this.language) {
            throw 'Error: language attribute must be defined in TdHighlightComponent.';
        }
        var codeElement = this.content.nativeElement;
        var code = codeElement.innerHTML;
        this.renderer.detachView([].slice.call(codeElement.childNodes));
        this.render(code, codeElement);
    };
    TdHighlightComponent.prototype.render = function (contents, codeElement) {
        var lines = contents.split('\n');
        // Remove empty lines
        lines = lines.filter(function (line) {
            return line.trim().length > 0;
        });
        // Make it so each line starts at 0 whitespace
        var firstLineWhitespace = lines[0].match(/^\s*/)[0];
        var startingWhitespaceRegex = new RegExp('^' + firstLineWhitespace);
        lines = lines.map(function (line) {
            return line
                .replace('=""', '') // remove empty values
                .replace(startingWhitespaceRegex, '')
                .replace(/\s+$/, '');
        });
        this.renderer.setElementClass(codeElement, 'highlight', true);
        var codeToParse = lines.join('\n')
            .replace(/\{ \{/gi, '{{').replace(/\} \}/gi, '}}')
            .replace(/&lt;/gi, '<').replace(/&gt;/gi, '>'); // replace with < and > to render HTML in angular 2
        if (this.language === 'html') {
            this.renderer.createText(codeElement, codeToParse, undefined);
            hljs.highlightBlock(codeElement);
        }
        else {
            var highlightedCode = hljs.highlight(this.language, codeToParse, true);
            highlightedCode.value = highlightedCode.value
                .replace(/=<span class="hljs-value">""<\/span>/gi, '')
                .replace('<head>', '')
                .replace('<head/>', '');
            codeElement.innerHTML = highlightedCode.value;
        }
    };
    __decorate([
        core_1.Input('lang'), 
        __metadata('design:type', String)
    ], TdHighlightComponent.prototype, "language", void 0);
    __decorate([
        core_1.ViewChild('highlight'), 
        __metadata('design:type', core_1.ElementRef)
    ], TdHighlightComponent.prototype, "content", void 0);
    TdHighlightComponent = __decorate([
        core_1.Component({selector: 'td-highlight',
            styles: ["pre, code, .highlight { font-family: Menlo, Monaco, \"Andale Mono\", \"lucida console\", \"Courier New\", monospace; } pre { display: block; overflow-x: auto; padding: 0; margin: 0; background: transparent; color: white; font-family: Menlo, Monaco, \"Andale Mono\", \"lucida console\", \"Courier New\", monospace; line-height: 1.45; tab-size: 2; -webkit-font-smoothing: auto; -webkit-text-size-adjust: none; position: relative; border-radius: 2px; font-size: 0.8rem; } code { margin: 0; padding: 0; overflow-wrap: break-word; white-space: pre-wrap; } .highlight { display: block; overflow-wrap: break-word; color: #e8eaf6; line-height: 1.5; margin: 0; } /* Use host as a parent here since hljs renders after dom & doesn't get Angular shadowdom */ :host { display: block; overflow-x: auto; background: #292348; color: white; padding: 16px; } :host + :host { margin-top: 16px; /* 2nd neighbor & beyond will have margin */ } :host /deep/ .hljs-comment, :host /deep/ .hljs-quote { color: #ce93d8; } :host /deep/ .hljs-variable, :host /deep/ .hljs-template-variable, :host /deep/ .hljs-tag, :host /deep/ .hljs-name, :host /deep/ .hljs-selector-id, :host /deep/ .hljs-selector-class, :host /deep/ .hljs-regexp, :host /deep/ .hljs-deletion { color: #ff80ab; } :host /deep/ .hljs-number, :host /deep/ .hljs-built_in, :host /deep/ .hljs-builtin-name, :host /deep/ .hljs-literal, :host /deep/ .hljs-type, :host /deep/ .hljs-params, :host /deep/ .hljs-meta, :host /deep/ .hljs-link { color: #ffcc80; } :host /deep/ .hljs-attribute { color: #ffab91; } :host /deep/ .hljs-string, :host /deep/ .hljs-symbol, :host /deep/ .hljs-bullet, :host /deep/ .hljs-addition { color: #e6ee9c; } :host /deep/ .hljs-title, :host /deep/ .hljs-section { color: #81d4fa; } :host /deep/ .hljs-keyword { color: #64ffda; } :host /deep/ .hljs-selector-tag { color: #82b1ff; } :host /deep/ .hljs-emphasis { font-style: italic; } :host /deep/ .hljs-strong { font-weight: bold; } /*# sourceMappingURL=highlight.component.css.map */ "],
            template: "<pre> <code #highlight> <ng-content></ng-content> </code> </pre>",
        }), 
        __metadata('design:paramtypes', [core_1.Renderer])
    ], TdHighlightComponent);
    return TdHighlightComponent;
}());
exports.TdHighlightComponent = TdHighlightComponent;

});

var highlight_module = createCommonjsModule(function (module, exports) {
"use strict";
var __decorate = (commonjsGlobal && commonjsGlobal.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (commonjsGlobal && commonjsGlobal.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = core;
var common_1 = common;
var highlight_component_1 = highlight_component;
var CovalentHighlightModule = (function () {
    function CovalentHighlightModule() {
    }
    CovalentHighlightModule.forRoot = function () {
        return {
            ngModule: CovalentHighlightModule,
            providers: [],
        };
    };
    CovalentHighlightModule = __decorate([
        core_1.NgModule({
            imports: [
                common_1.CommonModule,
            ],
            declarations: [
                highlight_component_1.TdHighlightComponent,
            ],
            exports: [
                highlight_component_1.TdHighlightComponent,
            ],
        }), 
        __metadata('design:paramtypes', [])
    ], CovalentHighlightModule);
    return CovalentHighlightModule;
}());
exports.CovalentHighlightModule = CovalentHighlightModule;

});

var index = createCommonjsModule(function (module, exports) {
"use strict";
var highlight_component_1 = highlight_component;
exports.TdHighlightComponent = highlight_component_1.TdHighlightComponent;
var highlight_module_1 = highlight_module;
exports.CovalentHighlightModule = highlight_module_1.CovalentHighlightModule;

});

var CovalentHighlightModule = index.CovalentHighlightModule;
var TdHighlightComponent = index.TdHighlightComponent;

exports['default'] = index;
exports.CovalentHighlightModule = CovalentHighlightModule;
exports.TdHighlightComponent = TdHighlightComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));